model{
#This does estimation of population state and lambda for lynx family groups
#priors==============
sigma.p ~ dunif(0,10)
tau.p <- 1/(sigma.p^2) # necessary in the process model dlnorm
sigma.o ~ dunif(0,100)
a0 ~ dnorm(0, 0.0001)
a1 ~ dnorm(0, 0.0001)

p ~ dbeta(y.a,y.b)  #get shape parameters a and b from mean and sd using moment matching

#base initial conditions on first observation of family groups
fg[1] ~ dpois(y1)
N[1] ~ dpois(y1/p)


#process model===============
  for(t in 2:(n.year+1)){  # the last year is a forecast with known harvest data
	  mu[t] <- log(max(.001,(N[t-1]-y.H[t-1])*exp(a0+a1*N[t-1]))) #
	  N[t] ~ dlnorm(mu[t], tau.p)
	}#end of process model


#data model===============
  for(t in 2:n.year){
    shape.obs[t] <- (N[t]^2)/(sigma.o^2) 
    rate.obs[t] <- N[t]/(sigma.o^2) 
    predict.N[t] ~ dgamma(shape.obs[t],rate.obs[t])
    fg[t] <- predict.N[t] * p
    y[t] ~ dpois(p*predict.N[t])
	}  #end of data model

#######################################################
#simulate new data for posterior predicitve check

for(t in 1:n.year){
	    y.rep[t] ~ dpois(p*N[t])
      #accumlate test statistics for posterior predictive check
	    sq[t] <- (y[t]-p*N[t])^2
	    sq.rep[t] <-(y.rep[t] - p*N[t])^2
}

#calculate Bayesian P value

fit <- sum(sq[])
fit.new <- sum(sq.rep[])
pvalue <- step(fit-fit.new)




	
} #end of model.  Be sure to have a blank line below.

