model{
#This does estimation of poplation state and lambda for lynx family groups
#priors==============
sigma.p ~ dunif(0,10)
tau.p <- 1/(sigma.p^2) # necessary in the process model dlnorm
sigma.o ~ dunif(0,100)
c0[1] ~ dnorm(0, 0.0001)
c0[2] ~ dnorm(0, 0.0001)
#b1 ~ dnorm(0, 0.00001) # Density dependence - NOT used

p ~ dbeta(y.a,y.b)  #get shape parameters a and b from mean and sd using moment matching

#base initial conditions on first observation of family groups
fg[1,1] ~ dpois(y1)
N[1,1] ~ dpois(y1/p)
fg[2,1] ~ dpois(y2)
N[2,1] ~ dpois(y2/p)
fg[3,1] ~ dpois(y3)
N[3,1] ~ dpois(y3/p)
fg[4,1] ~ dpois(y4)
N[4,1] ~ dpois(y4/p)



#process model===============
for(j in 1:n.region){
  for(t in 2:(n.year[j])){  # the last year is a forecast with known harvest data
	  mu[j,t] <- log(max(.001,(N[j,t-1]-y.H[index[j,t-1]])*exp(c0[n.area[j]]))) ## only legal hunting
	  N[j,t] ~ dlnorm(mu[j,t], tau.p)
   }
	}#end of process model


#data model===============
for(j in 1:n.region){
  for(t in 2:n.year[j]){
    shape.obs[j,t] <- (N[j,t]^2)/(sigma.o^2) 
    rate.obs[j,t] <- N[j,t]/(sigma.o^2) 
    predict.N[j,t] ~ dgamma(shape.obs[j,t],rate.obs[j,t])
    fg[j,t] <- predict.N[j,t] * p
    y[index[j,t]] ~ dpois(p*predict.N[j,t]) 
   }
	}  #end of data model

#######################################################
#simulate new data for posterior predicitve check

for(j in 1:n.region){
for(t in 1:n.year[j]){
	    y.rep[j,t] ~ dpois(p*N[j,t])
      #accumlate test statistics for posterior predictive check
	    sq[j,t] <- (y[index[j,t]]-p*N[j,t])^2
	    sq.rep[j,t] <-(y.rep[j,t] - p*N[j,t])^2
}
}
#calculate Bayesian P value for each region
for (j in 1:n.region) {
  fit[j] <- sum(sq[j,1:n.year[j]])
  fit.new[j] <- sum(sq.rep[j,1:n.year[j]])
  pvalue[j] <- step(fit[j]-fit.new[j])
}
#calculate Bayesian P value for each region
#for (j in 1:n.region) {
#  fit[j] <- sum(sq[j,1:n.year[j]])
#  fit.new[j] <- sum(sq.rep[j,1:n.year[j]])
#  pvalue[j] <- step(fit[j]-fit.new[j])
#}


	
} #end of model.  Be sure to have a blank line below.

